"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createDifferentialPackage = undefined;

var _bluebirdLst;

function _load_bluebirdLst() {
    return _bluebirdLst = require("bluebird-lst");
}

let createDifferentialPackage = exports.createDifferentialPackage = (() => {
    var _ref = (0, (_bluebirdLst || _load_bluebirdLst()).coroutine)(function* (archiveFile, archiveOptions, packager) {
        const args = (0, (_util || _load_util()).debug7zArgs)("a");
        (0, (_archive || _load_archive()).addZipArgs)(args);
        args.push(`-mm=${archiveOptions.method}`, "-mx=" + (process.env.TEST_APP_TMP_DIR == null ? "9" : "3"));
        args.push(archiveFile);
        // compute block map using compressed file data
        const blockMap = yield (0, (_blockMap || _load_blockMap()).computeBlockMap)(archiveFile);
        // https://superuser.com/a/966241, use leading ~ symbol to add file to the end (and avoid file rewrite)
        const blockMapFile = yield packager.info.tempDirManager.getTempFile({ prefix: "~" });
        yield (0, (_fsExtraP || _load_fsExtraP()).outputFile)(blockMapFile, blockMap);
        yield (0, (_util || _load_util()).spawn)((_zipBin || _load_zipBin()).path7za, args.concat(blockMapFile), {
            cwd: _path.dirname(archiveFile)
        });
        // rename to final name (file order will be not changed and preserved as is)
        yield (0, (_util || _load_util()).exec)((_zipBin || _load_zipBin()).path7za, ["rn", archiveFile, _path.basename(blockMapFile), "blockMap.yml"]);
    });

    return function createDifferentialPackage(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
    };
})();
//# sourceMappingURL=nsisPackage.js.map


var _util;

function _load_util() {
    return _util = require("electron-builder-util/src/util");
}

var _archive;

function _load_archive() {
    return _archive = require("../archive");
}

var _blockMap;

function _load_blockMap() {
    return _blockMap = require("../blockMap");
}

var _fsExtraP;

function _load_fsExtraP() {
    return _fsExtraP = require("fs-extra-p");
}

var _zipBin;

function _load_zipBin() {
    return _zipBin = require("7zip-bin");
}

var _path = _interopRequireWildcard(require("path"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }